目录链接:
力扣编程题-解法汇总_分享+记录-CSDN博客
GitHub同步刷题项目:
https://github.com/September26/java-algorithms
原题链接:. - 力扣(LeetCode)
描述:
给你一个下标从 0 开始的字符串 s
和一个单词字典 dictionary
。你需要将 s
分割成若干个 互不重叠 的子字符串,每个子字符串都在 dictionary
中出现过。s
中可能会有一些 额外的字符 不在任何子字符串中。
请你采取最优策略分割 s
,使剩下的字符 最少 。
示例 1:
输入:s = "leetscode", dictionary = ["leet","code","leetcode"] 输出:1 解释:将 s 分成两个子字符串:下标从 0 到 3 的 "leet" 和下标从 5 到 8 的 "code" 。只有 1 个字符没有使用(下标为 4),所以我们返回 1 。
示例 2:
输入:s = "sayhelloworld", dictionary = ["hello","world"] 输出:3 解释:将 s 分成两个子字符串:下标从 3 到 7 的 "hello" 和下标从 8 到 12 的 "world" 。下标为 0 ,1 和 2 的字符没有使用,所以我们返回 3 。
提示:
1 <= s.length <= 50
1 <= dictionary.length <= 50
1 <= dictionary[i].length <= 50
dictionary[i]
和s
只包含小写英文字母。dictionary
中的单词互不相同。
解题思路:
典型动态规划的题目。使用dp[i]代表到i位置时,使剩下的字符最少的数量。
那么dp[i]有两种来源,或者dp[i-1]+1,或者从某个位置跳跃而来。比如字符串abcd,字典["cd"]。
那么dp[3](位置d)要么dp[2]+1,要么dp[1](b的位置)直接拼接cd而来。
我们这样动态规划下去,最后dp[s.length()]就是我们想要的结果。
代码:
class Solution {
public int minExtraChar(String s, String[] dictionary) {
Map<String, List<String>> map = new HashMap<>();
for (String word : dictionary) {
String key = word.substring(word.length() - 1);
List<String> list = map.computeIfAbsent(key, k -> new ArrayList<>());
list.add(word);
}
int[] dp = new int[s.length() + 1];
for (int i = 0; i < s.length(); i++) {
dp[i + 1] = Math.min(dp[i], dp[i]) + 1;
String key = s.substring(i, i + 1);
List<String> list = map.get(key);
if (list == null || list.size() == 0) {
continue;
}
for (String str : list) {
String compareStr = s.substring(Math.max(0, i + 1 - str.length()), i + 1);
if (str.equals(compareStr)) {
dp[i + 1] = Math.min(dp[i + 1], dp[i - str.length() + 1]);
}
}
System.out.print(dp[i + 1]);
}
return dp[s.length()];
}
}